//*****************************************************************************
//*****************************************************************************
//  FILENAME: Baud_Gen.h
//   Version: 2.5, Updated on 2006/05/15 at 14:57:49
//  Generated by PSoC Designer ver 4.4  b1884 : 14 Jan, 2007
//
//  DESCRIPTION: Counter8 User Module C Language interface file
//               for the 22/24/27/29xxx PSoC family of devices
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#pragma fastcall16 Baud_Gen_EnableInt
#pragma fastcall16 Baud_Gen_DisableInt
#pragma fastcall16 Baud_Gen_Start
#pragma fastcall16 Baud_Gen_Stop
#pragma fastcall16 Baud_Gen_bReadCounter              // Read  DR0
#pragma fastcall16 Baud_Gen_WritePeriod               // Write DR1
#pragma fastcall16 Baud_Gen_bReadCompareValue         // Read  DR2
#pragma fastcall16 Baud_Gen_WriteCompareValue         // Write DR2

// The following symbols are deprecated.
// They may be omitted in future releases
//
#pragma fastcall16 bBaud_Gen_ReadCounter              // Read  DR0 (Deprecated)
#pragma fastcall16 bBaud_Gen_ReadCompareValue         // Read  DR2 (Deprecated)


//-------------------------------------------------
// Prototypes of the Baud_Gen API.
//-------------------------------------------------

extern void Baud_Gen_EnableInt(void);                           // Proxy Class 1
extern void Baud_Gen_DisableInt(void);                          // Proxy Class 1
extern void Baud_Gen_Start(void);                               // Proxy Class 1
extern void Baud_Gen_Stop(void);                                // Proxy Class 1
extern BYTE Baud_Gen_bReadCounter(void);                        // Proxy Class 1
extern void Baud_Gen_WritePeriod(BYTE bPeriod);                 // Proxy Class 1
extern BYTE Baud_Gen_bReadCompareValue(void);                   // Proxy Class 2
extern void Baud_Gen_WriteCompareValue(BYTE bCompareValue);     // Proxy Class 1

// The following functions are deprecated.
// They may be omitted in future releases
//
extern BYTE bBaud_Gen_ReadCounter(void);            // Deprecated
extern BYTE bBaud_Gen_ReadCompareValue(void);       // Deprecated


//--------------------------------------------------
// Constants for Baud_Gen API's.
//--------------------------------------------------

#define Baud_Gen_CONTROL_REG_START_BIT         ( 0x01 )
#define Baud_Gen_INT_REG_ADDR                  ( 0x0df )
#define Baud_Gen_INT_MASK                      ( 0x10 )


//--------------------------------------------------
// Constants for Baud_Gen user defined values
//--------------------------------------------------

#define Baud_Gen_PERIOD                        ( 0x9b )
#define Baud_Gen_COMPARE_VALUE                 ( 0x4e )


//-------------------------------------------------
// Register Addresses for Baud_Gen
//-------------------------------------------------

#pragma ioport  Baud_Gen_COUNTER_REG:   0x050              //DR0 Count register
BYTE            Baud_Gen_COUNTER_REG;
#pragma ioport  Baud_Gen_PERIOD_REG:    0x051              //DR1 Period register
BYTE            Baud_Gen_PERIOD_REG;
#pragma ioport  Baud_Gen_COMPARE_REG:   0x052              //DR2 Compare register
BYTE            Baud_Gen_COMPARE_REG;
#pragma ioport  Baud_Gen_CONTROL_REG:   0x053              //Control register
BYTE            Baud_Gen_CONTROL_REG;
#pragma ioport  Baud_Gen_FUNC_REG:  0x150                  //Function register
BYTE            Baud_Gen_FUNC_REG;
#pragma ioport  Baud_Gen_INPUT_REG: 0x151                  //Input register
BYTE            Baud_Gen_INPUT_REG;
#pragma ioport  Baud_Gen_OUTPUT_REG:    0x152              //Output register
BYTE            Baud_Gen_OUTPUT_REG;
#pragma ioport  Baud_Gen_INT_REG:       0x0df              //Interrupt Mask Register
BYTE            Baud_Gen_INT_REG;


//-------------------------------------------------
// Baud_Gen Macro 'Functions'
//-------------------------------------------------

#define Baud_Gen_Start_M \
   Baud_Gen_CONTROL_REG |=  Baud_Gen_CONTROL_REG_START_BIT

#define Baud_Gen_Stop_M  \
   Baud_Gen_CONTROL_REG &= ~Baud_Gen_CONTROL_REG_START_BIT

#define Baud_Gen_EnableInt_M   \
   M8C_EnableIntMask(Baud_Gen_INT_REG, Baud_Gen_INT_MASK)

#define Baud_Gen_DisableInt_M  \
   M8C_DisableIntMask(Baud_Gen_INT_REG, Baud_Gen_INT_MASK)


// end of file Baud_Gen.h
