;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: Baud_Gen.inc
;;   Version: 2.5, Updated on 2006/05/15 at 14:57:49
;;  Generated by PSoC Designer ver 4.4  b1884 : 14 Jan, 2007
;;
;;  DESCRIPTION: Assembler declarations for the Counter8 user module interface
;;               for the 22/24/27/29xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for Baud_Gen API's.
;--------------------------------------------------

Baud_Gen_CONTROL_REG_START_BIT:            equ 0x01    ; Control register start bit
Baud_Gen_INT_REG:                          equ 0x0df
Baud_Gen_INT_MASK:                         equ 0x10


;--------------------------------------------------
; Constants for Baud_Gen user defined values
;--------------------------------------------------

Baud_Gen_PERIOD:                           equ 0x9b
Baud_Gen_COMPARE_VALUE:                    equ 0x4e


;--------------------------------------------------
; Register Address Constants for Baud_Gen
;--------------------------------------------------

Baud_Gen_COUNTER_REG:                  equ 0x50   ; DR0 Counter register
Baud_Gen_PERIOD_REG:                   equ 0x51   ; DR1 Period register
Baud_Gen_COMPARE_REG:                  equ 0x52   ; DR2 CompareValue register
Baud_Gen_CONTROL_REG:                  equ 0x53   ; Control register
Baud_Gen_FUNC_REG:                     equ 0x50   ; Function register
Baud_Gen_INPUT_REG:                    equ 0x51   ; Input register
Baud_Gen_OUTPUT_REG:                   equ 0x52   ; Output register


;--------------------------------------------------
; Baud_Gen Macro 'Functions'
;--------------------------------------------------

   macro Baud_Gen_Start_M
   or    reg[Baud_Gen_CONTROL_REG],  Baud_Gen_CONTROL_REG_START_BIT
   endm

   macro Baud_Gen_Stop_M
   and   reg[Baud_Gen_CONTROL_REG], ~Baud_Gen_CONTROL_REG_START_BIT
   endm

   macro Baud_Gen_EnableInt_M
   M8C_EnableIntMask Baud_Gen_INT_REG, Baud_Gen_INT_MASK
   endm

   macro Baud_Gen_DisableInt_M
   M8C_DisableIntMask Baud_Gen_INT_REG, Baud_Gen_INT_MASK
   endm


; end of file Baud_Gen.inc
