//*****************************************************************************
//*****************************************************************************
//  FILENAME: RxTimer.h
//   Version: 2.5, Updated on 2006/06/19 at 11:17:22
//  Generated by PSoC Designer ver 4.4  b1884 : 14 Jan, 2007
//
//  DESCRIPTION: Timer16 User Module C Language interface file
//               for the 22/24/27/29xxx PSoC family of devices
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#pragma fastcall16 RxTimer_EnableInt
#pragma fastcall16 RxTimer_DisableInt
#pragma fastcall16 RxTimer_Start
#pragma fastcall16 RxTimer_Stop
#pragma fastcall16 RxTimer_wReadTimer                // Read  DR0
#pragma fastcall16 RxTimer_wReadTimerSaveCV          // Read  DR0      
#pragma fastcall16 RxTimer_WritePeriod               // Write DR1
#pragma fastcall16 RxTimer_wReadCompareValue         // Read  DR2
#pragma fastcall16 RxTimer_WriteCompareValue         // Write DR2

// The following symbols are deprecated.
// They may be omitted in future releases
//
#pragma fastcall16 wRxTimer_ReadCounter              // Read  DR0 "Obsolete"
#pragma fastcall16 wRxTimer_CaptureCounter           // Read  DR0 "Obsolete"
#pragma fastcall16 wRxTimer_ReadTimer                // Read  DR0 (Deprecated)
#pragma fastcall16 wRxTimer_ReadTimerSaveCV          // Read  DR0 (Deprecated)
#pragma fastcall16 wRxTimer_ReadCompareValue         // Read  DR2 (Deprecated)


//-------------------------------------------------
// Prototypes of the RxTimer API.
//-------------------------------------------------

extern void RxTimer_EnableInt(void);                           // Proxy 1
extern void RxTimer_DisableInt(void);                          // Proxy 1
extern void RxTimer_Start(void);                               // Proxy 1
extern void RxTimer_Stop(void);                                // Proxy 1
extern WORD RxTimer_wReadTimer(void);                          // Proxy 1
extern WORD RxTimer_wReadTimerSaveCV(void);                    // Proxy 2
extern void RxTimer_WritePeriod(WORD wPeriod);                 // Proxy 1
extern WORD RxTimer_wReadCompareValue(void);                   // Proxy 1
extern void RxTimer_WriteCompareValue(WORD wCompareValue);     // Proxy 1

// The following functions are deprecated.
// They may be omitted in future releases
//
extern WORD wRxTimer_ReadCompareValue(void);       // Deprecated
extern WORD wRxTimer_ReadTimerSaveCV(void);        // Deprecated
extern WORD wRxTimer_ReadCounter(void);            // Obsolete
extern WORD wRxTimer_ReadTimer(void);              // Deprecated
extern WORD wRxTimer_CaptureCounter(void);         // Obsolete


//--------------------------------------------------
// Constants for RxTimer API's.
//--------------------------------------------------

#define RxTimer_CONTROL_REG_START_BIT          ( 0x01 )
#define RxTimer_INT_REG_ADDR                   ( 0x0e1 )
#define RxTimer_INT_MASK                       ( 0x20 )


//--------------------------------------------------
// Constants for RxTimer user defined values
//--------------------------------------------------

#define RxTimer_PERIOD                         ( 0x8000 )
#define RxTimer_COMPARE_VALUE                  ( 0x0 )


//-------------------------------------------------
// Register Addresses for RxTimer
//-------------------------------------------------

#pragma ioport  RxTimer_COUNTER_LSB_REG:    0x030          //Count register LSB
BYTE            RxTimer_COUNTER_LSB_REG;
#pragma ioport  RxTimer_COUNTER_MSB_REG:    0x034          //Count register MSB
BYTE            RxTimer_COUNTER_MSB_REG;
#pragma ioport  RxTimer_PERIOD_LSB_REG: 0x031              //Period register LSB
BYTE            RxTimer_PERIOD_LSB_REG;
#pragma ioport  RxTimer_PERIOD_MSB_REG: 0x035              //Period register MSB
BYTE            RxTimer_PERIOD_MSB_REG;
#pragma ioport  RxTimer_COMPARE_LSB_REG:    0x032          //Compare register LSB
BYTE            RxTimer_COMPARE_LSB_REG;
#pragma ioport  RxTimer_COMPARE_MSB_REG:    0x036          //Compare register MSB
BYTE            RxTimer_COMPARE_MSB_REG;
#pragma ioport  RxTimer_CONTROL_LSB_REG:    0x033          //Control register LSB
BYTE            RxTimer_CONTROL_LSB_REG;
#pragma ioport  RxTimer_CONTROL_MSB_REG:    0x037          //Control register MSB
BYTE            RxTimer_CONTROL_MSB_REG;
#pragma ioport  RxTimer_FUNC_LSB_REG:   0x130              //Function register LSB
BYTE            RxTimer_FUNC_LSB_REG;
#pragma ioport  RxTimer_FUNC_MSB_REG:   0x134              //Function register MSB
BYTE            RxTimer_FUNC_MSB_REG;
#pragma ioport  RxTimer_INPUT_LSB_REG:  0x131              //Input register LSB
BYTE            RxTimer_INPUT_LSB_REG;
#pragma ioport  RxTimer_INPUT_MSB_REG:  0x135              //Input register MSB
BYTE            RxTimer_INPUT_MSB_REG;
#pragma ioport  RxTimer_OUTPUT_LSB_REG: 0x132              //Output register LSB
BYTE            RxTimer_OUTPUT_LSB_REG;
#pragma ioport  RxTimer_OUTPUT_MSB_REG: 0x136              //Output register MSB
BYTE            RxTimer_OUTPUT_MSB_REG;
#pragma ioport  RxTimer_INT_REG:       0x0e1               //Interrupt Mask Register
BYTE            RxTimer_INT_REG;


//-------------------------------------------------
// RxTimer Macro 'Functions'
//-------------------------------------------------

#define RxTimer_Start_M \
   ( RxTimer_CONTROL_LSB_REG |=  RxTimer_CONTROL_REG_START_BIT )

#define RxTimer_Stop_M  \
   ( RxTimer_CONTROL_LSB_REG &= ~RxTimer_CONTROL_REG_START_BIT )

#define RxTimer_EnableInt_M   \
   M8C_EnableIntMask(  RxTimer_INT_REG, RxTimer_INT_MASK )

#define RxTimer_DisableInt_M  \
   M8C_DisableIntMask( RxTimer_INT_REG, RxTimer_INT_MASK )


// end of file RxTimer.h


