;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: RxTimer.inc
;;   Version: 2.5, Updated on 2006/06/19 at 11:17:22
;;  Generated by PSoC Designer ver 4.4  b1884 : 14 Jan, 2007
;;
;;  DESCRIPTION: Assembler declarations for the Timer16 user module interface
;;               for the 22/24/27/29xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for RxTimer API's.
;--------------------------------------------------

RxTimer_CONTROL_REG_START_BIT:             equ 0x01    ; Control register start bit
RxTimer_INT_REG:                           equ 0x0e1
RxTimer_INT_MASK:                          equ 0x20


;--------------------------------------------------
; Constants for RxTimer user defined values
;--------------------------------------------------

RxTimer_PERIOD:                            equ 0x8000
RxTimer_COMPARE_VALUE:                     equ 0x0


;--------------------------------------------------
; Register Address Constants for RxTimer
;--------------------------------------------------

RxTimer_COUNTER_LSB_REG:               equ 0x30   ; DR0 Counter register
RxTimer_COUNTER_MSB_REG:               equ 0x34
RxTimer_PERIOD_LSB_REG:                equ 0x31   ; DR1 Period register
RxTimer_PERIOD_MSB_REG:                equ 0x35
RxTimer_COMPARE_LSB_REG:               equ 0x32   ; DR2 CompareValue register
RxTimer_COMPARE_MSB_REG:               equ 0x36
RxTimer_CONTROL_LSB_REG:               equ 0x33   ; Control register
RxTimer_CONTROL_MSB_REG:               equ 0x37
RxTimer_FUNC_LSB_REG:                  equ 0x30   ; Function register
RxTimer_FUNC_MSB_REG:                  equ 0x34
RxTimer_INPUT_LSB_REG:                 equ 0x31   ; Input register
RxTimer_INPUT_MSB_REG:                 equ 0x35
RxTimer_OUTPUT_LSB_REG:                equ 0x32   ; Output register
RxTimer_OUTPUT_MSB_REG:                equ 0x36


;--------------------------------------------------
; RxTimer Macro 'Functions'
;--------------------------------------------------

   macro RxTimer_Start_M
   or    reg[RxTimer_CONTROL_LSB_REG],  RxTimer_CONTROL_REG_START_BIT
   endm

   macro RxTimer_Stop_M
   and   reg[RxTimer_CONTROL_LSB_REG], ~RxTimer_CONTROL_REG_START_BIT
   endm

   macro RxTimer_EnableInt_M
   M8C_EnableIntMask RxTimer_INT_REG, RxTimer_INT_MASK
   endm

   macro RxTimer_DisableInt_M
   M8C_DisableIntMask RxTimer_INT_REG, RxTimer_INT_MASK
   endm


; end of file RxTimer.inc
