//*****************************************************************************
//*****************************************************************************
//  FILENAME: TxTimer.h
//   Version: 2.5, Updated on 2006/06/19 at 11:17:22
//  Generated by PSoC Designer ver 4.4  b1884 : 14 Jan, 2007
//
//  DESCRIPTION: Timer16 User Module C Language interface file
//               for the 22/24/27/29xxx PSoC family of devices
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#pragma fastcall16 TxTimer_EnableInt
#pragma fastcall16 TxTimer_DisableInt
#pragma fastcall16 TxTimer_Start
#pragma fastcall16 TxTimer_Stop
#pragma fastcall16 TxTimer_wReadTimer                // Read  DR0
#pragma fastcall16 TxTimer_wReadTimerSaveCV          // Read  DR0      
#pragma fastcall16 TxTimer_WritePeriod               // Write DR1
#pragma fastcall16 TxTimer_wReadCompareValue         // Read  DR2
#pragma fastcall16 TxTimer_WriteCompareValue         // Write DR2

// The following symbols are deprecated.
// They may be omitted in future releases
//
#pragma fastcall16 wTxTimer_ReadCounter              // Read  DR0 "Obsolete"
#pragma fastcall16 wTxTimer_CaptureCounter           // Read  DR0 "Obsolete"
#pragma fastcall16 wTxTimer_ReadTimer                // Read  DR0 (Deprecated)
#pragma fastcall16 wTxTimer_ReadTimerSaveCV          // Read  DR0 (Deprecated)
#pragma fastcall16 wTxTimer_ReadCompareValue         // Read  DR2 (Deprecated)


//-------------------------------------------------
// Prototypes of the TxTimer API.
//-------------------------------------------------

extern void TxTimer_EnableInt(void);                           // Proxy 1
extern void TxTimer_DisableInt(void);                          // Proxy 1
extern void TxTimer_Start(void);                               // Proxy 1
extern void TxTimer_Stop(void);                                // Proxy 1
extern WORD TxTimer_wReadTimer(void);                          // Proxy 1
extern WORD TxTimer_wReadTimerSaveCV(void);                    // Proxy 2
extern void TxTimer_WritePeriod(WORD wPeriod);                 // Proxy 1
extern WORD TxTimer_wReadCompareValue(void);                   // Proxy 1
extern void TxTimer_WriteCompareValue(WORD wCompareValue);     // Proxy 1

// The following functions are deprecated.
// They may be omitted in future releases
//
extern WORD wTxTimer_ReadCompareValue(void);       // Deprecated
extern WORD wTxTimer_ReadTimerSaveCV(void);        // Deprecated
extern WORD wTxTimer_ReadCounter(void);            // Obsolete
extern WORD wTxTimer_ReadTimer(void);              // Deprecated
extern WORD wTxTimer_CaptureCounter(void);         // Obsolete


//--------------------------------------------------
// Constants for TxTimer API's.
//--------------------------------------------------

#define TxTimer_CONTROL_REG_START_BIT          ( 0x01 )
#define TxTimer_INT_REG_ADDR                   ( 0x0e1 )
#define TxTimer_INT_MASK                       ( 0x02 )


//--------------------------------------------------
// Constants for TxTimer user defined values
//--------------------------------------------------

#define TxTimer_PERIOD                         ( 0x0 )
#define TxTimer_COMPARE_VALUE                  ( 0x0 )


//-------------------------------------------------
// Register Addresses for TxTimer
//-------------------------------------------------

#pragma ioport  TxTimer_COUNTER_LSB_REG:    0x020          //Count register LSB
BYTE            TxTimer_COUNTER_LSB_REG;
#pragma ioport  TxTimer_COUNTER_MSB_REG:    0x024          //Count register MSB
BYTE            TxTimer_COUNTER_MSB_REG;
#pragma ioport  TxTimer_PERIOD_LSB_REG: 0x021              //Period register LSB
BYTE            TxTimer_PERIOD_LSB_REG;
#pragma ioport  TxTimer_PERIOD_MSB_REG: 0x025              //Period register MSB
BYTE            TxTimer_PERIOD_MSB_REG;
#pragma ioport  TxTimer_COMPARE_LSB_REG:    0x022          //Compare register LSB
BYTE            TxTimer_COMPARE_LSB_REG;
#pragma ioport  TxTimer_COMPARE_MSB_REG:    0x026          //Compare register MSB
BYTE            TxTimer_COMPARE_MSB_REG;
#pragma ioport  TxTimer_CONTROL_LSB_REG:    0x023          //Control register LSB
BYTE            TxTimer_CONTROL_LSB_REG;
#pragma ioport  TxTimer_CONTROL_MSB_REG:    0x027          //Control register MSB
BYTE            TxTimer_CONTROL_MSB_REG;
#pragma ioport  TxTimer_FUNC_LSB_REG:   0x120              //Function register LSB
BYTE            TxTimer_FUNC_LSB_REG;
#pragma ioport  TxTimer_FUNC_MSB_REG:   0x124              //Function register MSB
BYTE            TxTimer_FUNC_MSB_REG;
#pragma ioport  TxTimer_INPUT_LSB_REG:  0x121              //Input register LSB
BYTE            TxTimer_INPUT_LSB_REG;
#pragma ioport  TxTimer_INPUT_MSB_REG:  0x125              //Input register MSB
BYTE            TxTimer_INPUT_MSB_REG;
#pragma ioport  TxTimer_OUTPUT_LSB_REG: 0x122              //Output register LSB
BYTE            TxTimer_OUTPUT_LSB_REG;
#pragma ioport  TxTimer_OUTPUT_MSB_REG: 0x126              //Output register MSB
BYTE            TxTimer_OUTPUT_MSB_REG;
#pragma ioport  TxTimer_INT_REG:       0x0e1               //Interrupt Mask Register
BYTE            TxTimer_INT_REG;


//-------------------------------------------------
// TxTimer Macro 'Functions'
//-------------------------------------------------

#define TxTimer_Start_M \
   ( TxTimer_CONTROL_LSB_REG |=  TxTimer_CONTROL_REG_START_BIT )

#define TxTimer_Stop_M  \
   ( TxTimer_CONTROL_LSB_REG &= ~TxTimer_CONTROL_REG_START_BIT )

#define TxTimer_EnableInt_M   \
   M8C_EnableIntMask(  TxTimer_INT_REG, TxTimer_INT_MASK )

#define TxTimer_DisableInt_M  \
   M8C_DisableIntMask( TxTimer_INT_REG, TxTimer_INT_MASK )


// end of file TxTimer.h


