;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: TxTimer.inc
;;   Version: 2.5, Updated on 2006/06/19 at 11:17:22
;;  Generated by PSoC Designer ver 4.4  b1884 : 14 Jan, 2007
;;
;;  DESCRIPTION: Assembler declarations for the Timer16 user module interface
;;               for the 22/24/27/29xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for TxTimer API's.
;--------------------------------------------------

TxTimer_CONTROL_REG_START_BIT:             equ 0x01    ; Control register start bit
TxTimer_INT_REG:                           equ 0x0e1
TxTimer_INT_MASK:                          equ 0x02


;--------------------------------------------------
; Constants for TxTimer user defined values
;--------------------------------------------------

TxTimer_PERIOD:                            equ 0x0
TxTimer_COMPARE_VALUE:                     equ 0x0


;--------------------------------------------------
; Register Address Constants for TxTimer
;--------------------------------------------------

TxTimer_COUNTER_LSB_REG:               equ 0x20   ; DR0 Counter register
TxTimer_COUNTER_MSB_REG:               equ 0x24
TxTimer_PERIOD_LSB_REG:                equ 0x21   ; DR1 Period register
TxTimer_PERIOD_MSB_REG:                equ 0x25
TxTimer_COMPARE_LSB_REG:               equ 0x22   ; DR2 CompareValue register
TxTimer_COMPARE_MSB_REG:               equ 0x26
TxTimer_CONTROL_LSB_REG:               equ 0x23   ; Control register
TxTimer_CONTROL_MSB_REG:               equ 0x27
TxTimer_FUNC_LSB_REG:                  equ 0x20   ; Function register
TxTimer_FUNC_MSB_REG:                  equ 0x24
TxTimer_INPUT_LSB_REG:                 equ 0x21   ; Input register
TxTimer_INPUT_MSB_REG:                 equ 0x25
TxTimer_OUTPUT_LSB_REG:                equ 0x22   ; Output register
TxTimer_OUTPUT_MSB_REG:                equ 0x26


;--------------------------------------------------
; TxTimer Macro 'Functions'
;--------------------------------------------------

   macro TxTimer_Start_M
   or    reg[TxTimer_CONTROL_LSB_REG],  TxTimer_CONTROL_REG_START_BIT
   endm

   macro TxTimer_Stop_M
   and   reg[TxTimer_CONTROL_LSB_REG], ~TxTimer_CONTROL_REG_START_BIT
   endm

   macro TxTimer_EnableInt_M
   M8C_EnableIntMask TxTimer_INT_REG, TxTimer_INT_MASK
   endm

   macro TxTimer_DisableInt_M
   M8C_DisableIntMask TxTimer_INT_REG, TxTimer_INT_MASK
   endm


; end of file TxTimer.inc
