//----------------------------------------------------------------------------
// James Mathews
// 3/10/2010
// New prospeckz template 
// Based on code from Steven Wong and Matthew Barnes
//----------------------------------------------------------------------------

//PSoc port defintions
#include "psocapi.h"
#include "psocgpioint.h"
//Prospeckz api
#include "prospeckz.h"
#include "prospeckz_radio.h"

#define MAX_RX_SIZE 64
unsigned char rxData[MAX_RX_SIZE];
receiveStatus_t rxStat;

//Packet size of 1 is too small, 2 seems to work
#define TX_SIZE 2
unsigned char txData[TX_SIZE];



#define RX

void main(void)
{

	// Turn off LED for power...	
	LED_Off;

	//Initiate and start network and application systems
	Radio_init(511);	//Init radio reciever
	Radio_setTxLevel(2); //Set the transmission strength...31 MAX	
	Radio_receiverOn;
	

	M8C_EnableIntMask(INT_MSK0,INT_MSK0_GPIO);	//Enable interupts on the GPIO port
	M8C_EnableGInt;	//Enable intterupts
	
	//Initlise the data
	txData[0] = 0;
}

#pragma interrupt_handler PSoC_GPIO_ISR
void PSoC_GPIO_ISR(void){
	//#ifdef PRINT_ALL_RX
	receiveStatus_t rxStat;
	//LED_BLUE_On;
	// Find the cause of the interrupt.
	
	// If FIFOP pin is high there is a complete packet or the buffer has overflowed...
	if (FIFOP_Data_ADDR & FIFOP_MASK) {
		//Now get the pakcet
		if((rxStat = Radio_receive( &rxData[0], MAX_RX_SIZE )).radioStatus == SUCCESS)
		{
			LED_Data_ADDR = rxData[0];
		}
	}
	else if(SWITCH_Pressed()){
		LED_Off;
		txData[0]++;
		
		//Don't overwrite upper the bit or it will get locked in the interrupt
		if(txData[0] >= 8)
			txData[0] = 0;
		LED_Data_ADDR = txData[0];
		
		//Transmit the packet
		Radio_transmit(&txData[0],TX_SIZE);
	}
}